import { world, system, ItemStack } from "@minecraft/server";
import { ActionFormData, ModalFormData } from "@minecraft/server-ui";

let expression = {};
world.beforeEvents.itemUse.subscribe(eventData => {
    const player = eventData.source;
    let DBname = player.nameTag;
    expression[DBname] = "0";
    if (eventData.itemStack.typeId == 'phone:phone_ui0') {
        system.run(() => {
            phoneScreen0(player);
            addPlayerMoney(player);
        })
    }
    if (eventData.itemStack.typeId == 'phone:phone_ui1') {
        system.run(() => {
            phoneScreen1(player);
            addPlayerMoney(player);
        })
    }
    if (eventData.itemStack.typeId == 'phone:phone_ui2') {
        system.run(() => {
            phoneScreen2(player);
            addPlayerMoney(player);
        })
    }
});

world.afterEvents.worldInitialize.subscribe(eventData => {
    const scoreboard = world.scoreboard.getObjective("emoney");
    if (scoreboard == undefined) {
        world.scoreboard.addObjective("emoney");
    }
    else return;
});

function addPlayerMoney(player) {
    player.runCommandAsync('scoreboard players add @s emoney 0')

}
function getScore(player, objective) {
    try {
        return world.scoreboard.getObjective(objective).getScore(player);
    } catch {
        return 0
    }
}
function SettingApp(player) {
    let form = new ActionFormData();
    form.title('setting_apps')
    form.button('back');
    form.show(player).then(result => {
        if (result.selection === 0) {
            BackButton(player)
        }
    })
}

function BackButton(player) {
    if (player.hasTag('Back0')) {
        phoneScreen0(player)
    }
    if (player.hasTag('Back1')) {
        phoneScreen1(player)
    }
    if (player.hasTag('Back2')) {
        phoneScreen2(player)
    }
}

function ThemeApp(player) {
    let form = new ActionFormData();
    form.title('Theme_app')
    form.body('New Phone Addon')
    form.button('Theme 1', 'textures/ui/phone_background_0');
    form.button('Theme 2', 'textures/ui/phone_background_1');
    form.button('Theme 3', 'textures/ui/phone_background_2');
    form.show(player).then(result => {
        if (result.selection === 0) {
            player.runCommandAsync('replaceitem entity @s slot.weapon.mainhand 1 phone:phone_ui0')
            phoneScreen0(player);
        }
        if (result.selection === 1) {
            player.runCommandAsync('replaceitem entity @s slot.weapon.mainhand 1 phone:phone_ui1')
            phoneScreen1(player)
        }
        if (result.selection === 2) {
            player.runCommandAsync('replaceitem entity @s slot.weapon.mainhand 1 phone:phone_ui2')
            phoneScreen2(player)
        }
    })
}



function phoneScreen0(player) {
    player.runCommandAsync('tag @s add Back0')
    player.runCommandAsync('tag @s remove Back1')
    player.runCommandAsync('tag @s remove Back2')
    const gui = new ActionFormData();
    gui.title('Phone_screen0')
    gui.button('Theme', 'textures/icon/theme_app')
    gui.button('Shop', 'textures/icon/shop_app')
    gui.button('Bank', 'textures/icon/bank_app')
    gui.button('Messages', 'textures/icon/msg_app')
    gui.button('Calculator', 'textures/icon/caculator_app')
    gui.button('Setting', 'textures/icon/setting_app')
    gui.button('Broswer', 'textures/icon/broswer_app')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            ThemeApp(player)
        }
        if (result.selection === 1) {
            shop_com_app(player, 0)
        }
        if (result.selection === 2) {
            bank_app(player)
        }
        if (result.selection === 3) {
            msg(player)
        }
        if (result.selection === 4) {
            Calculator(player)
        }
        if (result.selection === 5) {
            SettingApp(player)
        }
        if (result.selection === 6) {
            browser_splashScreen(player)
        }
    })
}

function phoneScreen1(player) {
    player.runCommandAsync('tag @s remove Back0')

    player.runCommandAsync('tag @s add Back1')

    player.runCommandAsync('tag @s remove Back2')
    const gui = new ActionFormData();
    gui.title('Phone_screen1')
    gui.button('Theme', 'textures/icon/theme_app')
    gui.button('Shop', 'textures/icon/shop_app')
    gui.button('Bank', 'textures/icon/bank_app')
    gui.button('Messages', 'textures/icon/msg_app')
    gui.button('Calculator', 'textures/icon/caculator_app')
    gui.button('Setting', 'textures/icon/setting_app')
    gui.button('Broswer', 'textures/icon/broswer_app')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            ThemeApp(player)
        }
        if (result.selection === 1) {
            shop_com_app(player, 0)
        }
        if (result.selection === 2) {
            bank_app(player)
        }
        if (result.selection === 3) {
            msg(player)
        }
        if (result.selection === 4) {
            Calculator(player)
        }
        if (result.selection === 5) {
            SettingApp(player)
        }
        if (result.selection === 6) {
            browser_splashScreen(player)
        }
    })
}

function phoneScreen2(player) {
    player.runCommandAsync('tag @s remove Back0')
    player.runCommandAsync('tag @s remove Back1')
    player.runCommandAsync('tag @s add Back2')
    const gui = new ActionFormData();
    gui.title('Phone_screen2')
    gui.button('Theme', 'textures/icon/theme_app')
    gui.button('Shop', 'textures/icon/shop_app')
    gui.button('Bank', 'textures/icon/bank_app')
    gui.button('Messages', 'textures/icon/msg_app')
    gui.button('Calculator', 'textures/icon/caculator_app')
    gui.button('Setting', 'textures/icon/setting_app')
    gui.button('Broswer', 'textures/icon/broswer_app')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            ThemeApp(player)
        }
        if (result.selection === 1) {
            shop_com_app(player, 0)
        }
        if (result.selection === 2) {
            bank_app(player)
        }
        if (result.selection === 3) {
            msg(player)
        }
        if (result.selection === 4) {
            Calculator(player)
        }
        if (result.selection === 5) {
            SettingApp(player)
        }
        if (result.selection === 6) {
            browser_splashScreen(player)
        }
    })
}

function evaluateExpression(expression, player) {
    let DBname = player.nameTag
    const tokens = expression[DBname].split(" ");

    let result = parseFloat(tokens[0]);
    let operator = null;

    for (let i = 1; i < tokens.length; i++) {
        if (["+", "-", "x", "÷"].includes(tokens[i])) {
            operator = tokens[i];
        } else {
            const number = parseFloat(tokens[i]);

            if (operator === "+") {
                result += number;
            } else if (operator === "-") {
                result -= number;
            } else if (operator === "x") {
                result *= number;
            } else if (operator === "÷") {
                if (number === 0) {
                    throw new Error("Division by zero");
                }
                result /= number;
            }

            operator = null;
        }
    }

    return result;
}

function Calculator(player) {
    let DBname = player.nameTag
    const calculator = new ActionFormData()
        .title("Calculator")
        .body(`${expression[DBname]}`);

    for (let i = 0; i <= 9; i++) {
        calculator.button(i.toString());
    }

    const operators = ["+", "-", "x", "÷"];
    operators.forEach((op) => calculator.button(op));

    calculator.button("=");
    calculator.button("AC");
    calculator.button("", "textures/icon/web_icon");
    calculator.button("", "textures/icon/emerald_icon");
    calculator.button("", "textures/icon/report_bug");
    calculator.button("", "textures/icon/cross_icon");

    calculator.show(player).then((response) => {
        if (response.canceled) {
            expression[DBname] = "0";
            return;
        }

        const selection = response.selection;

        if (selection >= 0 && selection <= 9) {
            if (expression[DBname] == "0") {
                expression[DBname] = ""
            }
            expression[DBname] += selection.toString();
        } else if (selection >= 10 && selection <= 13) {
            expression[DBname] += ` ${operators[selection - 10]} `;
        } else if (selection === 14) {
            try {
                const result = evaluateExpression(expression, player);
                expression[DBname] = result.toString();
            } catch (error) {
                expression[DBname] = "Error";
            }
        } else if (selection === 15) {
            expression[DBname] = "0";
        }
        else if (selection === 16) {
            expression[DBname] = "0";
            BackButton(player)
        }
        else if (selection === 17) {
            expression[DBname] = "0";
            BackButton(player)
        }
        else if (selection === 18) {

            expression[DBname] = "0";

            BackButton(player)
        }
        else if (selection === 19) {

            expression[DBname] = "0";

            BackButton(player)
        }
        if (selection != 16 && selection != 17 && selection != 18 && selection != 19) {
            Calculator(player);
        }
    });
}

function msg(player) {
    let msg = new ActionFormData();
    let playerNameList = world.getAllPlayers().map(p => p.name);
    msg.title("message_app");
    msg.body(` Online: ${playerNameList.length}`);
    msg.button(`§b§lBack`, 'textures/icon/back_button')
    playerNameList.forEach((value) => {
        if (player.nameTag === value) {
            msg.button(`${value} (You)`, 'textures/icon/friend_icon')
        }
        else {
            msg.button(`${value}`, 'textures/icon/friend_icon')
        }
    }
    );
    msg.show(player).then((result, value) => {
        const selection = result.selection;
        if (selection == 0) {
            BackButton(player)
        }
        if (selection >= 1 && selection <= playerNameList.length + 1) {
            const value = playerNameList[selection - 1]
            msgSend(player, value)
        }
    })
}

function msgSend(player, value) {
    const send = new ModalFormData();
    send.title("send_msg");
    send.textField(`§a@${value}`, "Enter the message");

    send.show(player).then((response) => {
        if (response.formValues[0]) {
            player.runCommand(`tellraw @s {"rawtext":[{"text":"§4×---------------------------×"},{"text":"\n"},{"translate":"§g§l           Notification"},{"text":"\n"},{"text":"§r§4×---------------------------×"},{"text":"\n"},{"translate":"§r>>${response.formValues[0]}"},{"text":"\n"},{"text":"§a[Send message to ${value}]"},{"text":"\n"},{"text":"§4×---------------------------×"}]}`)

            player.runCommand(`tellraw ${value} {"rawtext":[{"text":"§4×---------------------------×"},{"text":"\n"},{"translate":"§g§l           Notification"},{"text":"\n"},{"text":"§r§4×---------------------------×"},{"text":"\n"},{"translate":"§r>>${response.formValues[0]}"},{"text":"\n"},{"text":"§a[Received message from ${player.nameTag}]"},{"text":"\n"},{"text":"§4×---------------------------×"}]}`)
        }
    })
}

function bank_app(player) {
    let moneyScore = getScore(player, 'emoney')
    let bankGUI = new ActionFormData();
    bankGUI.title('bank_app');
    bankGUI.body(`§l$${moneyScore}`);
    bankGUI.button("withdrawal");
    bankGUI.button("deposit");
    bankGUI.button("send money");
    bankGUI.button("Refresh");
    bankGUI.button("Back", 'textures/icon/send_button_hover');

    bankGUI.show(player).then(result => {
        if (result.selection === 0) {
            withdrawal_app(player)
        }
        if (result.selection === 1) {
            deposit_app(player)
        }
        if (result.selection === 2) {
            banck_player_detech(player)
        }
        if (result.selection === 3) {
            bank_app(player)
        }
        if (result.selection === 4) {
            BackButton(player)
        }
    })
}

function withdrawal_app(player) {
    let moneyScore = getScore(player, 'emoney')
    let withBank = new ActionFormData();
    withBank.title('withdrawal');
    withBank.body(`§l$${moneyScore}`);
    withBank.button('$1');
    withBank.button('$10');
    withBank.button('$50');
    withBank.button('$100');
    withBank.button('Back');
    withBank.show(player).then(result => {
        if (result.selection === 0) {
            if (moneyScore >= 1) {
                player.runCommand(`gamerule sendcommandfeedback false`)
                player.runCommand(`give @s emerald 1`)
                player.runCommand(`scoreboard players remove @s emoney 1`)
                player.runCommand(`gamerule sendcommandfeedback true`)
            }
            withdrawal_app(player)
        }
        if (result.selection === 1) {
            if (moneyScore >= 10) {
                player.runCommand(`gamerule sendcommandfeedback false`)
                player.runCommand(`give @s emerald 10`)
                player.runCommand(`scoreboard players remove @s emoney 10`)
                player.runCommand(`gamerule sendcommandfeedback true`)
            }
            withdrawal_app(player)
        }
        if (result.selection === 2) {
            if (moneyScore >= 50) {
                player.runCommand(`gamerule sendcommandfeedback false`)
                player.runCommand(`give @s emerald 50`)
                player.runCommand(`scoreboard players remove @s emoney 50`)
                player.runCommand(`gamerule sendcommandfeedback true`)
            }
            withdrawal_app(player)
        }
        if (result.selection === 3) {
            if (moneyScore >= 100) {
                player.runCommand(`gamerule sendcommandfeedback false`)
                player.runCommand(`give @s emerald 100`)
                player.runCommand(`scoreboard players remove @s emoney 100`)
                player.runCommand(`gamerule sendcommandfeedback true`)
            }
            withdrawal_app(player)
        }
        if (result.selection === 4) {
            bank_app(player)
        }
    });
}

function deposit_app(player) {
    let moneyScore = getScore(player, 'emoney')
    let depositBank = new ActionFormData();
    depositBank.title('deposit');
    depositBank.body(`§l$${moneyScore}`);
    depositBank.button('$1');
    depositBank.button('$10');
    depositBank.button('$50');
    depositBank.button('$100');
    depositBank.button('Back');
    depositBank.show(player).then(result => {
        if (result.selection === 0) {
            player.runCommand(`function sell_emerald1`)
            deposit_app(player)
        }
        if (result.selection === 1) {
            player.runCommand(`function sell_emerald10`)
            deposit_app(player)
        }
        if (result.selection === 2) {
            player.runCommand(`function sell_emerald50`)
            deposit_app(player)
        }
        if (result.selection === 3) {
            player.runCommand(`function sell_emerald100`)
            deposit_app(player)
        }
        if (result.selection === 4) {
            bank_app(player)
        }
    });
}

let BankServer = {};

function send_money_bank(player, values) {
    let moneyScore = getScore(player, 'emoney');
    let DBname = player.nameTag;
    if (!BankServer[DBname]) {
        BankServer[DBname] = 0
    }
    let smb = new ActionFormData();
    smb.title("send_money_button");
    smb.body(`$${BankServer[DBname]}`);
    for (let i = 0; i <= 9; i++) {
        smb.button(i.toString());
    }
    smb.button("", "textures/icon/cross_icon");
    smb.button("", "textures/icon/backspace_icon");
    smb.button("back");
    smb.button("send");
    smb.show(player).then(result => {
        if (result.canceled) {
            BankServer[DBname] = 0;
            return;
        }
        let selection = result.selection;
        if (selection >= 0 && selection <= 9) {
            if (BankServer[DBname] == 0) {
                BankServer[DBname] = ""
            }
            BankServer[DBname] += selection;
            send_money_bank(player, values)
        }
        if (selection === 10) {
            if (BankServer[DBname] >= 1) {
                BankServer[DBname] = BankServer[DBname].slice(0, -1);
            }
            send_money_bank(player, values)
        }
        if (selection === 11) {
            BankServer[DBname] = 0;
            send_money_bank(player, values)
        }
        if (selection === 12) {
            BankServer[DBname] = 0;
            bank_app(player)
        }
        if (selection === 13) {
            if (moneyScore >= BankServer[DBname] && BankServer[DBname] >= 1) {
                player.runCommand(`scoreboard players add ${values} emoney ${BankServer[DBname]}`);
                player.runCommand(`tellraw ${values} {"rawtext":[{"text":"§4×---------------------------×"},{"text":"\n"},{"translate":"§g§l           Notification"},{"text":"\n"},{"text":"§r§4×---------------------------×"},{"text":"\n"},{"text": "§a$${BankServer[DBname]}§r credit to your account."},{"text":"\n"},{"text":"§b[Received money from ${DBname}]"},{"text":"\n"},{"text":"§4×---------------------------×"}]}`)
                player.runCommand(`scoreboard players remove ${DBname} emoney ${BankServer[DBname]}`);
                player.runCommand(`tellraw ${DBname} {"rawtext":[{"text":"§4×---------------------------×"},{"text":"\n"},{"translate":"§g§l           Notification"},{"text":"\n"},{"text":"§r§4×---------------------------×"},{"text":"\n"},{"text": "§a$${BankServer[DBname]}§r debit from your account."},{"text":"\n"},{"text":"§b[Send money to ${values}]"},{"text":"\n"},{"text":"§4×---------------------------×"}]}`)
            }
            BankServer[DBname] = 0;
            bank_app(player);
        }
    })
}

function banck_player_detech(player) {
    let banck_player_detech = new ActionFormData();
    let playerNameList0 = world.getAllPlayers().map(p => p.name);
    banck_player_detech.title("send_money_bank");
    banck_player_detech.body(` Online: ${playerNameList0.length}`);
    banck_player_detech.button(`§b§lBack`, 'textures/icon/back_button')
    playerNameList0.forEach((value) => {
        if (player.nameTag === value) {
            banck_player_detech.button(`${value} (You)`, 'textures/icon/friend_icon')
        }
        else {
            banck_player_detech.button(`${value}`, 'textures/icon/friend_icon')
        }
    }
    );
    banck_player_detech.show(player).then((result, value) => {
        const selection = result.selection;
        if (selection == 0) {
            bank_app(player)
        }
        if (selection >= 1 && selection <= playerNameList0.length + 1) {
            const values = playerNameList0[selection - 1]
            send_money_bank(player, values);
        }
    })
}


function browser_splashScreen(player) {
    let broAPP = new ActionFormData();
    broAPP.title('browser_splashScreen');
    broAPP.body('Under development..');
    broAPP.button('back');
    broAPP.show(player).then(result => {
        if (result.selection === 0) {
            BackButton(player)
        }
    })
}


function shop_com_app(player, value) {
    let broAPP = new ActionFormData();
    broAPP.title('shop_com_app');
    broAPP.button('back');
    broAPP.button('search');
    broAPP.button('banner');
    broAPP.button('<');
    broAPP.button('>');
    if (value === 0) {
        broAPP.button('1', "textures/items/glow_berries");
        broAPP.button('2', "textures/items/experience_bottle");
        broAPP.button('3', "textures/items/villagebell");
    }
    if (value === 1) {
        broAPP.button('1', "textures/items/iron_axe");
        broAPP.button('2', "textures/items/honeycomb");
        broAPP.button('3', "textures/items/gold_pickaxe");
    }
    if (value === 2) {
        broAPP.button('1', "textures/items/torchflower_seeds");
        broAPP.button('2', "textures/items/spyglass");
        broAPP.button('3', "textures/items/sniffer_egg");
    }
    broAPP.button('Food');
    broAPP.button('1', "textures/items/apple_golden");
    broAPP.button('2', "textures/items/beetroot");
    broAPP.button('Tools');
    broAPP.button('1', "textures/items/netherite_axe");
    broAPP.button('2', "textures/items/diamond_sword");
    broAPP.button('Armor');
    broAPP.button('1', "textures/items/diamond_chestplate");
    broAPP.button('2', "textures/items/gold_boots");
    broAPP.button('special');
    broAPP.button('1', "textures/items/wolf_armor");
    broAPP.button('2', "textures/items/potato_poisonous");
    broAPP.show(player).then(result => {
        let selections = result.selection;
        if (selections === 0) {
            BackButton(player)
        }
        if (selections === 1) {
            search_shop_system(player, value)
        }
        if (selections === 2) {
            offer_shop_system(player, value)
        }
        if (selections === 3) {
            if (value === 0) {
                shop_com_app(player, 2)
            }
            if (value === 1) {
                shop_com_app(player, 0)
            }
            if (value === 2) {
                shop_com_app(player, 1)
            }
        }
        if (selections === 4) {
            if (value === 0) {
                shop_com_app(player, 1)
            }
            if (value === 1) {
                shop_com_app(player, 2)
            }
            if (value === 2) {
                shop_com_app(player, 0)
            }
        }
        if (selections === 5) {
            if (value === 0) {
                itemsPurchase(player, 'glow berries', 'glow_berries', 10, 0, 10, 'glow_berries', "Home")
            }
            if (value === 1) {
                itemsPurchase(player, 'iron axe', 'iron_axe', 10, 1, 10, 'iron_axe', "Home")
            }
            if (value === 2) {
                itemsPurchase(player, 'torchflower seeds', 'torchflower_seeds', 2, 2, 0, 'torchflower_seeds', "Home")
            }
        }
        if (selections === 6) {
            if (value === 0) {
                itemsPurchase(player, 'experience bottle', 'experience_bottle', 3, 0, 0, 'experience_bottle', "Home")
            }
            if (value === 1) {
                itemsPurchase(player, 'honeycomb', 'honeycomb', 3, 1, 0, 'honeycomb', "Home")
            }
            if (value === 2) {
                itemsPurchase(player, 'spyglass', 'spyglass', 5, 2, 5, 'spyglass', "Home")
            }

        }
        if (selections === 7) {
            if (value === 0) {
                itemsPurchase(player, 'villagebell', 'bell', 10, 0, 10, 'villagebell', "Home")
            }
            if (value === 1) {
                itemsPurchase(player, 'gold pickaxe', 'golden_pickaxe', 10, 1, 10, 'gold_pickaxe', "Home")
            }
            if (value === 2) {
                itemsPurchase(player, 'sniffer egg', 'sniffer_egg', 25, 2, 15, 'sniffer_egg', "Home")
            }

        }
        if (selections === 8) {
            Food_shop_system(player, value)
        }
        if (selections === 9) {
            itemsPurchase(player, 'golden apple', 'golden_apple', 8, value, 20, 'apple_golden', "Home")
        }
        if (selections === 10) {
            itemsPurchase(player, 'beetroot', 'beetroot', 2, value, 5, 'beetroot', "Home")
        }
        if (selections === 11) {
            Tools_shop_system(player, value)
        }
        if (selections === 12) {
            itemsPurchase(player, 'netherite axe', 'netherite_axe', 30, value, 15, 'netherite_axe', "Home")
        }
        if (selections === 13) {
            itemsPurchase(player, 'diamond sword', 'diamond_sword', 10, value, 2, 'diamond_sword', "Home")
        }

        if (selections === 14) {
            Armor_shop_system(player, value)
        }
        if (selections === 15) {
            itemsPurchase(player, 'diamond chestplate', 'diamond_chestplate', 30, value, 20, 'diamond_chestplate', "Home")
        }
        if (selections === 16) {
            itemsPurchase(player, 'gold boots', 'golden_boots', 10, value, 10, 'gold_boots', "Home")
        }
        if (selections === 17) {
            Special_shop_system(player, value)
        }
        if (selections === 18) {
            itemsPurchase(player, 'wolf armor', 'wolf_armor', 40, value, 30, 'wolf_armor', "Home")
        }
        if (selections === 19) {
            itemsPurchase(player, 'poisonous potato', 'poisonous_potato', 5, value, 3, 'potato_poisonous', "Home")
        }
    })
}
let itemsCOUNT = {};
function itemsPurchase(player, itemsName, itemId, price, value, discount, texture, backsystem) {
    let Emoney = getScore(player, 'emoney');
    if (!itemsCOUNT[player.nameTag]) {
        itemsCOUNT[player.nameTag] = 1
    }
    let getDataAndMakeData = itemsCOUNT[player.nameTag] * price;
    let discountADD = getDataAndMakeData * discount / 100;
    let item = new ActionFormData();
    item.title('Order');
    item.body(`do you want purcahse this item?`)
    item.button('back');
    item.button('-');
    item.button(`${itemsCOUNT[player.nameTag]}`);
    item.button('+');
    item.button(`$${getDataAndMakeData}`)
    item.button('purchase');
    item.button(`${itemsName}`, `textures/items/${texture}`)
    item.button(`${discount}%% Discount`)
    item.button(`-$${discountADD.toFixed()}`)
    let totalPrice = getDataAndMakeData - discountADD.toFixed()
    item.button(`Total Price : $${totalPrice}`)
    item.show(player).then(result => {
        if (result.canceled) {
            itemsCOUNT[player.nameTag] = 1;
            return;
        }
        if (result.selection === 0) {
            if (backsystem === "Home") {
                shop_com_app(player, value)
            }
            if (backsystem === "Food") {
                Food_shop_system(player, value)
            }
            if (backsystem === "Armor") {
                Armor_shop_system(player, value)
            }
            if (backsystem === "Tools") {
                Tools_shop_system(player, value)
            }
            if (backsystem === "Plant") {
                Plant_shop_system(player, value)
            }
            if (backsystem === "Special") {
                Special_shop_system(player, value)
            }
            if (backsystem === "Offer") {
                offer_shop_system(player, value)
            }
            itemsCOUNT[player.nameTag] = 1;
        }
        if (result.selection === 1) {
            if (itemsCOUNT[player.nameTag] >= 2) {
                itemsCOUNT[player.nameTag] = itemsCOUNT[player.nameTag] - 1;
            }
            itemsPurchase(player, itemsName, itemId, price, value, discount, texture, backsystem)
        }
        if (result.selection === 2 || result.selection === 4) {
            itemsPurchase(player, itemsName, itemId, price, value, discount, texture, backsystem)
        }
        if (result.selection === 3) {
            if (itemsCOUNT[player.nameTag] <= 19) {
                itemsCOUNT[player.nameTag] = itemsCOUNT[player.nameTag] + 1;
            }
            itemsPurchase(player, itemsName, itemId, price, value, discount, texture, backsystem)
        }
        if (result.selection === 5) {
            if (Emoney >= totalPrice) {
                player.runCommand(`scoreboard players remove @s emoney ${totalPrice}`);
                player.runCommand(`give @s ${itemId} ${itemsCOUNT[player.nameTag]}`);
                itemsCOUNT[player.nameTag] = 1;
                player.runCommand(`tellraw @s {"rawtext":[{"text":"§aItem Purchase Successfully..."}]}`)
            }
            else {
                player.runCommand(`tellraw @s {"rawtext":[{"text":"§4!Insufficient Balance"}]}`)
            }
        }
    })
}

function search_shop_system(player, value) {
    let searchShop = new ActionFormData();
    searchShop.title('search_shop_system');
    searchShop.button('back');
    searchShop.button('Food');
    searchShop.button('Armor');
    searchShop.button('Tools');
    searchShop.button('Plant');
    searchShop.button('Special');
    searchShop.show(player).then(result => {
        if (result.selection === 0) {
            shop_com_app(player, value)
        }
        if (result.selection === 1) {
            Food_shop_system(player, value)
        }
        if (result.selection === 2) {
            Armor_shop_system(player, value)
        }
        if (result.selection === 3) {
            Tools_shop_system(player, value)
        }
        if (result.selection === 4) {
            Plant_shop_system(player, value)
        }
        if (result.selection === 5) {
            Special_shop_system(player, value)
        }
    })
}
function Food_shop_system(player, value) {
    let searchShop = new ActionFormData();
    searchShop.title('items_get_data');
    searchShop.body('Food items');
    searchShop.button('back');
    searchShop.button("apple", "textures/items/apple");
    searchShop.button("berries", "textures/items/sweet_berries");
    searchShop.button("melon", "textures/items/melon");
    searchShop.button("bread", "textures/items/bread");
    searchShop.button("carrot", "textures/items/carrot");
    searchShop.button("chicken", "textures/items/chicken_cooked");
    searchShop.button("mutton", "textures/items/mutton_cooked");
    searchShop.button("beef", "textures/items/beef_cooked");
    searchShop.show(player).then(result => {
        if (result.selection === 0) {
            shop_com_app(player, value)
        }
        if (result.selection === 1) {
            itemsPurchase(player, 'apple', 'apple', 2, value, 25, 'apple', "Food")
        }
        if (result.selection === 2) {
            itemsPurchase(player, 'sweet berries', 'sweet_berries', 2, value, 25, 'sweet_berries', "Food")
        }
        if (result.selection === 3) {
            itemsPurchase(player, 'melon', 'melon_slice', 3, value, 25, 'melon', "Food")
        }
        if (result.selection === 4) {
            itemsPurchase(player, 'bread', 'bread', 3, value, 25, 'bread', "Food")
        }
        if (result.selection === 5) {
            itemsPurchase(player, 'carrot', 'carrot', 2, value, 25, 'carrot', "Food")
        }
        if (result.selection === 6) {
            itemsPurchase(player, 'cooked chicken', 'cooked_chicken', 4, value, 25, 'chicken_cooked', "Food")
        }
        if (result.selection === 7) {
            itemsPurchase(player, 'cooked mutton', 'cooked_mutton', 4, value, 25, 'mutton_cooked', "Food")
        }
        if (result.selection === 8) {
            itemsPurchase(player, 'cooked beef', 'cooked_beef', 4, value, 25, 'beef_cooked', "Food")
        }
    })
}
function Armor_shop_system(player, value) {
    let searchShop1 = new ActionFormData();
    searchShop1.title('items_get_data');
    searchShop1.body('Armor items');
    searchShop1.button('back');
    searchShop1.button("horse armor", "textures/items/diamond_horse_armor");
    searchShop1.button("Legging", "textures/items/diamond_leggings");
    searchShop1.button("chestplate", "textures/items/iron_chestplate");
    searchShop1.button("Boots", "textures/items/netherite_boots");
    searchShop1.button("elytra", "textures/items/elytra");
    searchShop1.button("helmet", "textures/items/gold_helmet");
    searchShop1.button("helmet", "textures/items/turtle_helmet");
    searchShop1.button("saddle", "textures/items/saddle");
    searchShop1.show(player).then(result => {
        if (result.selection === 0) {
            shop_com_app(player, value)
        }
        if (result.selection === 1) {
            itemsPurchase(player, 'horse armor', 'diamond_horse_armor', 30, value, 25, 'diamond_horse_armor', "Armor")
        }
        if (result.selection === 2) {
            itemsPurchase(player, ' diamond leggings', 'diamond_leggings', 25, value, 25, 'diamond_leggings', "Armor")
        }
        if (result.selection === 3) {
            itemsPurchase(player, 'iron chestplate', 'iron_chestplate', 15, value, 15, 'iron_chestplate', "Armor")
        }
        if (result.selection === 4) {
            itemsPurchase(player, 'netherite boots', 'netherite_boots', 35, value, 20, 'netherite_boots', "Armor")
        }
        if (result.selection === 5) {
            itemsPurchase(player, 'elytra', 'elytra', 80, value, 20, 'elytra', "Armor")
        }
        if (result.selection === 6) {
            itemsPurchase(player, 'golden helmet', 'golden_helmet', 15, value, 10, 'gold_helmet', "Armor")
        }
        if (result.selection === 7) {
            itemsPurchase(player, 'turtle helmet', 'turtle_helmet', 30, value, 30, 'turtle_helmet', "Armor")
        }
        if (result.selection === 8) {
            itemsPurchase(player, 'saddle', 'saddle', 50, value, 15, 'saddle', "Armor")
        }
    })
}
function Tools_shop_system(player, value) {
    let searchShop2 = new ActionFormData();
    searchShop2.title('items_get_data');
    searchShop2.body('Tools items');
    searchShop2.button('back');
    searchShop2.button("axe", "textures/items/diamond_axe");
    searchShop2.button("pickaxe", "textures/items/diamond_pickaxe");
    searchShop2.button("flint", "textures/items/flint_and_steel");
    searchShop2.button("crossbow", "textures/items/crossbow_standby");
    searchShop2.button("Sword", "textures/items/diamond_sword");
    searchShop2.button("Bow", "textures/items/bow_standby");
    searchShop2.button("Arrow", "textures/items/arrow");
    searchShop2.button("Trident", "textures/items/trident");
    searchShop2.show(player).then(result => {
        if (result.selection === 0) {
            shop_com_app(player, value)
        }
        if (result.selection === 1) {
            itemsPurchase(player, 'diamond axe', 'diamond_axe', 21, value, 15, 'diamond_axe', "Tools")
        }
        if (result.selection === 2) {
            itemsPurchase(player, 'diamond pickaxe', 'diamond_pickaxe', 25, value, 15, 'diamond_pickaxe', "Tools")
        }
        if (result.selection === 3) {
            itemsPurchase(player, 'flintand steel', 'flint_and_steel', 10, value, 15, 'flint_and_steel', "Tools")
        }
        if (result.selection === 4) {
            itemsPurchase(player, 'crossbow', 'crossbow', 20, value, 25, 'crossbow_standby', "Tools")
        }
        if (result.selection === 5) {
            itemsPurchase(player, 'iron sword', 'iron_sword', 20, value, 20, 'iron_sword', "Tools")
        }
        if (result.selection === 6) {
            itemsPurchase(player, 'bow', 'bow', 10, value, 10, 'bow_standby', "Tools")
        }
        if (result.selection === 7) {
            itemsPurchase(player, 'arrow', 'arrow', 2, value, 30, 'arrow', "Tools")
        }
        if (result.selection === 8) {
            itemsPurchase(player, 'trident', 'trident', 50, value, 15, 'trident', "Tools")
        }
    })
}
function Plant_shop_system(player, value) {
    let searchShop2 = new ActionFormData();
    searchShop2.title('items_get_data');
    searchShop2.body('Plant items');
    searchShop2.button('back');
    searchShop2.button("melon seed", "textures/items/seeds_melon");
    searchShop2.button("pumpkin seed", "textures/items/seeds_pumpkin");
    searchShop2.button("beetroot seed", "textures/items/seeds_beetroot");
    searchShop2.button("wheat seed", "textures/items/seeds_wheat");
    searchShop2.button("mangrove", "textures/items/mangrove_propagule");
    searchShop2.button("pitcher pod", "textures/items/pitcher_pod");
    searchShop2.button("bamboo", "textures/items/bamboo");
    searchShop2.button("bone meal", "textures/items/dye_powder_white");
    searchShop2.show(player).then(result => {
        if (result.selection === 0) {
            shop_com_app(player, value)
        }
        if (result.selection === 1) {
            itemsPurchase(player, 'melon seed', 'melon_seeds', 10, value, 15, 'seeds_melon', "Plant")
        }
        if (result.selection === 2) {
            itemsPurchase(player, 'pumpkin seed', 'pumpkin_seeds', 10, value, 15, 'seeds_pumpkin', "Plant")
        }
        if (result.selection === 3) {
            itemsPurchase(player, 'beetroot seed', 'beetroot_seeds', 10, value, 15, 'seeds_beetroot', "Plant")
        }
        if (result.selection === 4) {
            itemsPurchase(player, 'wheat seed', 'wheat_seeds', 10, value, 25, 'seeds_wheat', "Plant")
        }
        if (result.selection === 5) {
            itemsPurchase(player, 'mangrove propagule', 'mangrove_propagule', 15, value, 20, 'mangrove_propagule', "Plant")
        }
        if (result.selection === 6) {
            itemsPurchase(player, 'pitcher pod', 'pitcher_pod', 15, value, 10, 'pitcher_pod', "Plant")
        }
        if (result.selection === 7) {
            itemsPurchase(player, 'bamboo', 'bamboo', 15, value, 30, 'bamboo', "Plant")
        }
        if (result.selection === 8) {
            itemsPurchase(player, 'bone meal', 'bone_meal', 5, value, 15, 'dye_powder_white', "Plant")
        }
    })
}
function Special_shop_system(player, value) {
    let searchShop2 = new ActionFormData();
    searchShop2.title('items_get_data');
    searchShop2.body('Special items');
    searchShop2.button('back');
    searchShop2.button("trim", "textures/items/silence_armor_trim_smithing_template");
    searchShop2.button("trim", "textures/items/tide_armor_trim_smithing_template");
    searchShop2.button("nether star", "textures/items/nether_star");
    searchShop2.button("nametag", "textures/items/name_tag");
    searchShop2.button("totem", "textures/items/totem");
    searchShop2.button("bamboo raft", "textures/items/bamboo_raft");
    searchShop2.button("membrane", "textures/items/phantom_membrane");
    searchShop2.button("prize pottery", "textures/items/prize_pottery_sherd");
    searchShop2.show(player).then(result => {
        if (result.selection === 0) {
            shop_com_app(player, value)
        }
        if (result.selection === 1) {
            itemsPurchase(player, 'silence armor trim', 'silence_armor_trim_smithing_template', 40, value, 25, 'silence_armor_trim_smithing_template', "Special")
        }
        if (result.selection === 2) {
            itemsPurchase(player, 'tide armor trim', 'tide_armor_trim_smithing_template', 40, value, 25, 'tide_armor_trim_smithing_template', "Special")
        }
        if (result.selection === 3) {
            itemsPurchase(player, 'nether star', 'nether_star', 80, value, 20, 'nether_star', "Special")
        }
        if (result.selection === 4) {
            itemsPurchase(player, 'nametag', 'name_tag', 20, value, 15, 'name_tag', "Special")
        }
        if (result.selection === 5) {
            itemsPurchase(player, 'totem', 'totem_of_undying', 60, value, 20, 'totem', "Special")
        }
        if (result.selection === 6) {
            itemsPurchase(player, 'bamboo raft', 'bamboo_raft', 25, value, 30, 'bamboo_raft', "Special")
        }
        if (result.selection === 7) {
            itemsPurchase(player, 'phantom membrane', 'phantom_membrane', 20, value, 10, 'phantom_membrane', "Special")
        }
        if (result.selection === 8) {
            itemsPurchase(player, 'prize pottery', 'prize_pottery_sherd', 40, value, 5, 'prize_pottery_sherd', "Special")
        }
    })
}
function offer_shop_system(player, value) {
    let searchShop2 = new ActionFormData();
    searchShop2.title('items_get_data');
    searchShop2.body('Special offers');
    searchShop2.button('back');
    searchShop2.button("chestplate", "textures/items/netherite_chestplate");
    searchShop2.button("helmet", "textures/items/iron_helmet");
    searchShop2.button("boots", "textures/items/diamond_boots");
    searchShop2.button("sword", "textures/items/gold_sword");
    searchShop2.button("axolotl", "textures/items/bucket_axolotl");
    searchShop2.button("ender Pearl", "textures/items/ender_pearl");
    searchShop2.button("golden carrot", "textures/items/carrot_golden");
    searchShop2.button("rabbit", "textures/items/rabbit_cooked");
    searchShop2.show(player).then(result => {
        if (result.selection === 0) {
            shop_com_app(player, value)
        }
        if (result.selection === 1) {
            itemsPurchase(player, 'netherite chestplate', 'netherite_chestplate', 40, value, 50, 'netherite_chestplate', "Offer")
        }
        if (result.selection === 2) {
            itemsPurchase(player, 'iron helmet', 'iron_helmet', 20, value, 50, 'iron_helmet', "Offer")
        }
        if (result.selection === 3) {
            itemsPurchase(player, 'diamond boots', 'diamond_boots', 30, value, 50, 'diamond_boots', "Offer")
        }
        if (result.selection === 4) {
            itemsPurchase(player, 'golden sword', 'golden_sword', 10, value, 50, 'gold_sword', "Offer")
        }
        if (result.selection === 5) {
            itemsPurchase(player, 'bucket of axolotl', 'axolotl_bucket', 40, value, 50, 'bucket_axolotl', "Offer")
        }
        if (result.selection === 6) {
            itemsPurchase(player, 'ender Pearl', 'ender_pearl', 15, value, 50, 'ender_pearl', "Offer")
        }
        if (result.selection === 7) {
            itemsPurchase(player, 'golden carrot', 'golden_carrot', 10, value, 50, 'carrot_golden', "Offer")
        }
        if (result.selection === 8) {
            itemsPurchase(player, 'cooked rabbit', 'cooked_rabbit', 15, value, 50, 'rabbit_cooked', "Offer")
        }
    })
}